import React from 'react';
require('./index.css');
let addIconSrc = UTILPATH.localImg.plusIcon;
let refreshIconSrc = UTILPATH.localImg.refreshIcon;
/**
 * 组件说明 需要props type 与imgSrc
 * type == custom 为要显示的图片
 * type == add 为添加图片的icon 不需要传入imgSrc
 * type == refresh 为刷新的icon 不需要传入imgSrc
 * handleClikImgFunc 为点击当前图片的方法
 * noCloseBtn 为是否有删除按钮
 * handleClikCloseFunc 为点击删除按钮的方法
 */
export default class ImgToolComponent extends React.Component{
    constructor(props){
        super(props);
    }

    render(){
        let props = this.props;
        let type = props.type;
        let imgSrc = '';
        let noCloseBtn = props.noCloseBtn;
        let handleClikImgFunc = props.handleClikImgFunc;
        let handleClikCloseFunc = props.handleClikCloseFunc;

        switch(type){
            case "custom":
                imgSrc = props.imgSrc;
                break;
            case "add":
                imgSrc = addIconSrc;
                break;
            case "refresh":
                imgSrc = refreshIconSrc;
                break;

        }
        return(
            <div className={"ImgToolComponent"}>
                <div className={"imgItem"}>
                    <img  src={imgSrc} alt="" onClick={handleClikImgFunc()}/>
                    {
                        noCloseBtn?"":(<span className={"closeBtn"} onClick={handleClikCloseFunc()}>×</span>)
                    }
                </div>
            </div>
        )

    }
}