'use strict';
import React from 'react';
import { connect } from  'react-redux';
import SwiperComponent from '../../components/CommonComponent/SwiperComponent/SwiperComponent'
import ImgToolComponent from '../../components/CommonComponent/CommonSmallComponent/ImgToolComponent/CommonSmalContainer'
import EditProblemItem from '../../components/OtherQuestionComponent/EditProblemComponent'
import TextArea from "../TextAreaContainer/TextAreaContainer";
import {getOtherProblem} from '../../actions/otherQuestion'
import trouble from "../../reducers/trouble";
require('./index.css');
export default class OtherQuestionContainer extends React.Component{
    constructor(props){
        super(props)
        this.state = {
            showTextArea:false,
            tmpText:"",
            problemList:{},
            currentProblemId:''
        }
    }
    componentWillMount() {
        let {dispatch,initStart,state} = this.props;
        // 请求 初始数据接口
        let postData = {};
        initStart(postData);

    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
        let {state} = nextProps;
        let {otherQuestion} = state;
        let {feeds} = otherQuestion;
        let problemList = {};
       feeds.map((item,index)=>{
           problemList[item.id] = {}
           problemList[item.id].remarkText = ""
       });
       this.setState({
           problemList:problemList
       })
    }
    componentWillUnmount(){
    }
    /*
    * 输入故障备注信息部分
    * */
    // 1. 显示编辑备注组件
    handleShowRemark(troubleId){
        let currentProblem = this.state.problemList[troubleId];
        let tmpText = currentProblem.remarkText;
        this.setState({
            showTextArea : true,
            tmpText: tmpText,
            currentProblemId:troubleId
        })
    }
    // 2. 在编辑备注页面组件 点击返回
    handleEditGoBack(){
        this.setState({
            showTextArea:false
        })
        console.log("点击文本框页的返回键");

    }
    // 3. 在编辑备注组件页面 点击保存
    handleSaveRemarkText(text){
        let troubleId = this.state.currentProblemId;
        let currentRemark = text;
        let problemList = this.state.problemList;
        problemList[troubleId].remarkText = currentRemark;
        this.setState({
            problemList:problemList,
            showTextArea:false
        },()=>{
            console.log(this.state.problemList)
        })
    }
    /*
    * 点击录入更多 添加新故障
    * */

    handleAddNewTroble(){
        let postData = {};
        let {addNewProblem} = this.props;
        postData.employeeId = "dfdf";
        postData.employeeId = "dfdf";

        addNewProblem();
    }
    /*
    * 删除已经编辑的的问题
    * */
    handleDeleteProblem(){
        console.log("删除编辑的问题");
    }
    /*
    *添加照片
    * */
    handleAddImg(){
        console.log("添加照片")
    }


    /*
    *刷新当前图片
    * */
    handleRefreshProbelmImg(){
        console.log("刷新当前问题备注图片")
    }
    /*
    * 删除图片
    * */
    handleDeleteImg(){
        console.log("删除图片")
    }



    /*
    * 整体提交已经编辑的问题
    * */
    handleSubmitProblemList(){
        console.log("=======提交已经编辑的问题==")
    }
    /*
    * 直接跳过
    * */
    handleOverPass(){
        console.log("++++++++跳过=====")
    }


    render(){
        //let 难道初始化的数据：
        let {state,addNewProblem} = this.props;
        console.log(state)
        let {otherQuestion} = state;
        let {feeds,problems} = otherQuestion;
        let editProblemItemUI = '';
        let swiperCount = 0;
        feeds && feeds.length>0 ?(
            editProblemItemUI = feeds.map((i,k)=>{
                console.log(this.state);
                let troubleId = i.id;
                let currentRemark = this.state.problemList[troubleId].remarkText;
                return <EditProblemItem
                    trouleId = {troubleId}
                    clickEdit = {this.handleShowRemark.bind(this,troubleId)}
                    problemInfo = {problems}
                    baseInfo = {i}
                    remarkText = {currentRemark}
                    deleteProblem = {()=>(this.handleDeleteProblem.bind(this))}
                    addImg = {()=>(this.handleAddImg.bind(this))}
                    reRreshImg = {()=>(this.handleRefreshProbelmImg.bind(this))}
                    deleteImg = {()=>(this.handleDeleteImg.bind(this))}
                    key={k}/>;
            })
            ):""
        feeds && feeds.length>0 ?(
            swiperCount = feeds.length
        ):""

        let swiperOptions = {
            width : 1396,
            spaceBetween: 30,
            freeMode:true,
            // slidesPerView: 2.6,
        };
        let swiperContainer = CONFIG.swiperContainers.editProblemSwiperContainer;



        return (
            this.state.showTextArea?(
                <TextArea
                    text={this.state.tmpText}
                    goBack={this.handleEditGoBack.bind(this)}
                    saveText={this.handleSaveRemarkText.bind(this)}
                ></TextArea>
            ):(
                <div className={"OtherQuestionContainer"}>
                    <div className={"otherQuestionTitleContainer"}>你是否有其他问题希望反馈(<i>*</i>必填项)</div>
                    <div className={"editOtherQuestionContainer clearfix"}>
                        <SwiperComponent
                            swiperContainer={swiperContainer} swiperOptions={swiperOptions} swiperCount={swiperCount}
                        >
                            {editProblemItemUI}
                        </SwiperComponent>
                    </div>
                    <div className={"opeationContainer clearfix"}>
                        <button className={"addMoreBtn"} onClick={this.handleAddNewTroble.bind(this)}><span>+</span>录入更多</button>
                        <button className={"noMoreBtn"}>没有更多</button>
                    </div>
                    <div className={"overPass"} onClick={this.handleOverPass.bind(this)}>跳过</div>

                </div>
            )

        )
    }
}