'use strict';
import React from 'react'
import { connect }  from 'react-redux';

import {getStoreInfo} from "../../actions/getStore";
import {getTroubleList} from "../../actions/getTroubles";
import {initGetOtherProblem,addNewProbem} from "../../actions/otherQuestion"
import {getRefreshImg} from "../../actions/refreshImg"
import PopupComponent from '../../components/CommonComponent/PopupComponent/PopupComponent'
import TroubleContainer from '../TroubleContainer/TroubleContainer'
import ScanBarCodeContainer from '../ScanBarCodeContainer/ScanBarCodeContaienr'
import ReportDamagesListContainer from '../ReportDamagesListContainer/ReportDamagesListContainer'
import OtherQuestionContainer from '../OtherQuestionContainer/OtherQuestionContainer'
import HomeContainer from '../HomeContainer/HomeContainer'
import FinishAskContainer from '../FinishAskContainer/FinishAskContainer'
import ChooseTaskContainer from '../ChooseTaskContainer/ChooseTaskContainer'
import Button from '../../components/CommonComponent/ButtonComponent/ButtonComponent';
import Clock from '../../components/CommonComponent/ClockComponent/ClockComponent'

require('./index.css')

const showPage = CONFIG.showPage;

const headerStatus = CONFIG.headerStatus;


const defaultPopupInfo = {
        showPopup : false, //是否显示弹窗
        popupChild : null, // 自定义弹窗内部htmls
        popupText : "", //默认弹窗的文本 （必填）
        popupButtons : [], // 默认弹窗的按钮
        classNames : '' //自定义类名
    };

class PageContainer extends React.Component {
    constructor(props) {
        super(props);
        // UTILPATH.socket.getIp();
        this.state = {
            showPage : showPage[4],
            lastPage : '',
            page : null,
            popupInfo : defaultPopupInfo,
            pageStyle : {},
            lastPageStyle:{},
        };
        this.getPages = this.getPages.bind(this);
        this.showPopup = this.showPopup.bind(this);
        this.hidePopup = this.hidePopup.bind(this);
        this.showQrCode = this.showQrCode.bind(this);
        this.saveLastPage = this.saveLastPage.bind(this);
        this.goBack = this.goBack.bind(this);
        this.handleTouch = this.handleTouch.bind(this);
        this.beginCountBack = this.beginCountBack.bind(this);
        this.endCountBack = this.endCountBack.bind(this);
        this.showAlarm = this.showAlarm.bind(this);

        this.maxCountBackTime = 300;
        this.count = 1000;
        this.countbackTimer = null;
        this.countBackTime = -1;

    }
    componentWillMount() {
        let {dispatch} = this.props;
        dispatch(getStoreInfo());

        let pages = this.getPages();
        this.setState({
            page : pages
        })
    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
    }
    componentWillUnmount(){
    }



    //开始倒计时,看有没有操作，只是在整个开门过程中才监听

    beginCountBack(){
        this.countBackTime = this.maxCountBackTime;
        clearTimeout(this.countbackTimer);
        this.countbackTimer = null;
        this.countBack.bind(this)();
    }

    endCountBack(){
        this.countbackTimer = -1;
        clearTimeout(this.countbackTimer);
        this.countbackTimer = null;
    }

    countBack(){
        if(!this.countbackTimer && this.countBackTime >= 0){
            this.countBackTime--;
            this.countbackTimer = window.setTimeout(()=>{
                if(this.countBackTime > 0){
                    clearTimeout(this.countbackTimer);
                    this.countbackTimer = null;
                    this.countBack();
                }else{
                    //超过300s未点击，进入异常状态
                    clearTimeout(this.countbackTimer);
                    this.countbackTimer = null;
                    let btnDom = <Button key={"pagecountBack1"} style={{'width':'260px'}} text={"关闭"} option={this.beginCountBack}/>
                    let clockDom = <Clock key={"pagecountBack2"} totalTime={60}
                                          style={{'width':'260px','marginLeft':'30px','borderRadius':'10px'}}
                                          callback={this.showAlarm}
                    />
                    this.showPopup({
                        popupText : '您是否还在店铺准备执行您的任务',
                        popupButtons:[btnDom,clockDom]
                    })
                }
            },this.count);
        }

    }
    //弹出警告弹窗，并报警
    showAlarm(){
        console.log("showAlarm");
    }



    hidePopup(){
        this.setState({
            popupInfo : defaultPopupInfo
        })
    }
    showPopup(info){
        //eg : info = {popupText:'test',popupButtons:[{text : '返回',option:FUNCTION}]}
        let popupInfo = Object.assign({},defaultPopupInfo,info);
        if(
            (   popupInfo.popupChild ||
                popupInfo.popupText ||
                (popupInfo.popupButtons && popupInfo.popupButtons.length > 0)
            ) && !popupInfo.showPopup
        ){
            popupInfo.showPopup = true; //以防未设置显示弹窗，做此判断。
        }

        this.setState({
            popupInfo : popupInfo,
        })
    }

    showQrCode(url){
        this.setState({
            showPage: showPage[5],
            tempInfo : {
                text : text,
                url : url
            }
        })
    }

    saveLastPage(page,pageStyle){
        this.setState({
            lastPage : page,
            lastPageStyle : pageStyle
        })
    }


    goBack(){
        console.log("goback")
        let lastPage = this.state.lastPage;
        let pageStyle = this.state.lastPageStyle;
        this.setState({
            showPage: lastPage,
            pageStyle : pageStyle

        })
    }

    getPages(){
        let pages = null;
        let{state,dispatch} = this.props;
        switch (this.state.showPage){
            case showPage[1]:
                pages = <TroubleContainer
                    troubleList={state.troubleList}
                    refreshImg = {state.refreshImg}
                    storeInfo={state.storeInfo}
                    userInfo={state.userInfo}
                    initTroubleList={()=>dispatch(getTroubleList())}
                    showTextArea={(text)=>this.showTextArea(text)}
                    showPopup={(info)=>this.showPopup(info)}
                    hidePopup={()=>this.hidePopup()}
                    getRefreshImg={(errorId,type)=>dispatch(getRefreshImg(errorId,type))}
                />;
                break;
            case showPage[2]:
                pages = <ScanBarCodeContainer />;
                break;
            case showPage[3]:
                pages = <ReportDamagesListContainer />;
                break;
            case showPage[4]:
                pages = <OtherQuestionContainer
                            initStart = {(postData)=>dispatch(initGetOtherProblem(postData))}
                            addNewProblem = {(postData)=>dispatch(addNewProbem(postData))}
                            state = {state}
                        />;
                break;
            case showPage[7]:
                pages = <HomeContainer />;
                break;
            case showPage[8]:
                pages = <FinishAskContainer />;
                break;
            case showPage[9]:
                pages = <ChooseTaskContainer />;
                break;
        }
        return pages;
    }

    handleTouch(){
        this.countBackTime = this.maxCountBackTime;
    }

    render() {
        let {state} = this.props;
        return (
            <div className={"pageContainer "} style={this.state.pageStyle} onTouchStart={()=>this.handleTouch()}>

                <PopupComponent popupInfo={this.state.popupInfo} />
                {this.getPages()}
            </div>
        )
    }
}

function select(store) {
    return Object.assign({}, {state: store})
}

export default connect(select)(PageContainer)