import React from 'react';
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
require('./index.css');

export default class TextAreaContainer extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            text : ''
        }
        this.getOtherHeader = this.getOtherHeader.bind(this);
        this.saveText = this.saveText.bind(this);
    }

    componentWillMount() {
        let {text} = this.props;
        this.setState({
            text : text
        })
    }

    handleChange(e){
        let value = e.target.value;
        this.setState({text: value});
    }

    saveText(){
        if(this.state.text){
            this.props.saveText(this.state.text)
        }
    }

    getOtherHeader(){
        let {goBack} = this.props;
        return <div className={"otherHeader font32 clearfix"}>
            <div className={"fl colfff"} onClick={()=>goBack()}>
                <i className={"iconfont middle icon font58 icon-circle-left circleIcon"}></i>
                <span className={"middle"}>编辑检查结果</span>
            </div>
            <div className={"fr "+(this.state.text ? 'colff7860':'col999')} onClick={()=>this.saveText()}>
                <i className={"iconfont middle icon font60 icon-save saveIcon"}></i>
                <span className={"middle"}>保存</span>
            </div>
        </div>
    }

    render(){
        return (
            <div>
                <HeaderComponent
                    showHeader={CONFIG.headerStatus[2]}
                >
                    {this.getOtherHeader()}
                </HeaderComponent>
                <div className={"textAreaContainer"}>
                    <div className={"textAreaDiv font30 col999"} >
                        <textarea className={"textAreaBox font30 col999"} name="" id="" cols="30" rows="10" onChange={this.handleChange.bind(this)} value={this.state.text} placeholder={"点击输入"}></textarea>
                    </div>
                </div>
            </div>

        )
    }
}
